' The Class block below provides a form handler for VBScript using IE automation
'
Class IEForm
	Private objIE, oForm, oShell, oIEdoc, oTitle, oHeading, nError
	'-----------------------------
	Private Sub Class_Initialize()
	'           ==================
		Set objIE = CreateObject("InternetExplorer.Application")
		Set oShell = CreateObject("WScript.Shell")
		nError = 0
		with objIE
			.Navigate "about:blank"
			On Error Resume Next
			Do Until .ReadyState = 4
				ReportGenerator.Sleep 1000
				' use popup to put a 1 second delay in this loop waiting for IE control to initialize
				If Err.Number <> 0 Then oShell.Popup Dic("ParametersFormLoad"),1,ReportGenerator.SkinName
			Loop
			On Error Goto 0
            		.ToolBar = 0
            		.StatusBar = 0
            		.Width = 800
            		.Height = 600
            		with .document
                		.writeln "<HTML id='head'>"&_
                    			"<STYLE>"&_
                    			".hclass {font-family: tahoma; font-size: 12pt;}"&_
                    			"body, table {font-family: tahoma;line-height: 10pt; font-size: 8pt; background-color: rgb(224, 223, 227);}"&_
                    			"legend {color: black;font-weight: bold;}</STYLE>"&_
                    			"<HEAD class='hclass'><TITLE id=title>Narrative Report</TITLE></HEAD>"&_
                    			"<BODY id='body' onunload='VBScript:MsgBox(""Quitting""):Quit'>"&_
					"<SCRIPT language='VBScript'>"&vbNewline&_
					"Sub Pressed()"&vbNewline&_
					"window.event.srcElement.previousSibling.value=""yes"""&vbNewline&_
					"End Sub"&vbNewline&_
					"Sub Quit()"&vbNewline&_
					"window.document.getElementById(""quit"").value=""yes"""&vbNewline&_
					"End Sub"&vbNewline&_
					"</SCRIPT>"&_
					"<INPUT id='quit' type='hidden' />"&_
		    			"<H3 id='heading' style='text-align: center;'></H3>"&_
		    			"<FORM id='form'></FORM>"&_
		    			"</BODY></HTML>"
                		'   objIE.Left = (.all("body").clientwidth/2) - 320
                		'   objIE.Top = (.all("body").clientheight/2) - 240
            		end with
			.visible = False
        	end with
	
		Set oIEdoc = objIE.document
		Set oForm = oIEdoc.getElementById("form")
		Set oTitle = oIEdoc.getElementById("title")
		Set oHeading = oIEdoc.getElementById("heading")
	End Sub
	'-------------------------------------------
	Private Sub Class_Terminate()
		On Error Resume Next
		objIE.quit
		Set objIE = Nothing
	End Sub
	'-------------------------------------------

	Public Property Get Error
		Error = nError
	End Property

	Public Property Get Form
		Set Form = oForm
	End Property

	Public Property Let Show(fVisible)
		objIE.visible = fVisible
	End Property

	Public Property Let Title(strText)
		oTitle.text = strText
		oHeading.innerHTML = strText
	End Property
		
	Function LineBreak(oParent)
		Dim oElement, oChild
		Set oElement = oIEdoc.createElement("br")
		Set oElement = oParent.appendChild(oElement)
	End Function
	Function Division(oParent, strAlign)
		Dim oElement, oChild
		Set oElement = oIEdoc.createElement("div")
		Set oElement = oParent.appendChild(oElement)
		If strAlign <> "" Then oElement.style.textAlign = strAlign
		Set Division = oElement
	End Function
	Function Group(oParent, strTitle)
		Dim oElement, oNode, oChild
		Set oNode = oIEdoc.createElement("<fieldset style='border-style:groove; border-width:2px;'>")
		Set oElement = oParent.appendChild(oNode)
		Set oNode = oIEdoc.createElement("legend")
		Set oChild = oElement.appendChild(oNode)
		oChild.innerHTML = strTitle
		Set Group = oElement
	End Function
	Function Table(oParent, strBorder, strAlign)
		Dim oElement, oChild
		Set oElement = oIEdoc.createElement("div")
		Set oElement = oParent.appendChild(oElement)
		If strAlign <> "" Then oElement.align = strAlign
	  	Set oChild = oIEdoc.createElement("table")
		Set oElement = oElement.appendChild(oChild)
		oElement.setAttribute "border",strBorder
	  	Set oChild = oIEdoc.createElement("tbody")
		Set Table = oElement.appendChild(oChild)
	End Function
	Function Row(oParent)
		Dim oNode
		Set oNode = oIEdoc.createElement("tr")
		Set Row = oParent.appendChild(oNode)
	End Function
	Function Cell(oParent, strWidth, strAlign)
		Dim oNode
		Set oNode = oIEdoc.createElement("<td style='width: " & strWidth & "; text-align: " & strAlign & ";'>")
		Set Cell = oParent.appendChild(oNode)
	End Function
	Function Selection(oParent)
		Dim oNode
		Set oNode = oIEdoc.createElement("select")
		Set Selection = oParent.appendChild(oNode)
	End Function
	Function SetOption(oParent, strValue, strText, fSelected)
		Dim oNode, oChild
		Set oNode = oIEdoc.createElement("<option value='" + strValue + "'>")
		Set oChild = oParent.appendChild(oNode)
		oChild.text = strText
		oChild.selected = fSelected
		Set SetOption = oChild
	End Function
	Function GetOption(oElement)
			GetOption = oElement.options(oElement.selectedIndex).value
	End Function
	Function SetField(oParent, strType, strValue, nLength, nSize)
		Dim oNode, oChild, strOnClick
		If strType = "button" Then
			Set oNode = oIEdoc.createElement("<input type='hidden'>")
			Set oNode = oParent.appendChild(oNode)
			strOnClick = " onClick='Pressed()'"
		End If
		Set oNode = oIEdoc.createElement("<input type='" & strType & "' size='" & nLength & "' maxlength='" & nSize & "' value='" & strValue & "'" & strOnClick & ">")
		Set oChild = oParent.appendChild(oNode)
		Set SetField = oChild
	End Function
	Function GetField(oElement)
		GetField = oElement.value
	End Function
	Function SetText(oParent, strText)
		Dim oNode, oChild
		Set oNode = oIEdoc.createTextNode(strText)
		Set oChild = oParent.appendChild(oNode)
		Set SetText = oChild
	End Function

	Function IsClicked(oElement)
		IsClicked = oElement.previousSibling.value = "yes"
		If Err.Number <> 0 Then nError = Err.Number
	End Function
	
End Class