Class TimelineInfo
'
'	Used to hold Timeline data, i.e. start & end dates, no. of nodes, time inteval unit, time interval width (pixels)
'
	Private IsUpdated_, Unit_, Pixels_, DateMin_, DateMax_, Nodes_, DateLimit_

	Private Sub Class_Initialize()
		Nodes_ = 0
		DateMin_ = DateValue("31 " & MonthName(12) & " 9999")
		DateMax_ = DateValue("01 " & MonthName(1) & " 100")
		DateLimit_ = DateMax_
		IsUpdated_ = False
	End Sub

	Public Property Get DateMax
		DateMax = DateMax_
	End Property

	Public Property Get DateMin
		DateMin = DateMin_
	End Property
	
	Public Property Get Nodes
		Nodes = Nodes_
	End Property

	Public Property Get Unit
		If Not IsUpdated_ Then Update_
		Unit = Unit_
	End Property

	Public Property Get Pixels
		If Not IsUpdated_ Then Update_
		Pixels = Pixels_
	End Property

	Private Sub CheckDate_(strDate)
		Dim nDate
		If IsDate(strDate) Then
			nDate = DateValue(strDate)
			If nDate < DateMin_ Then DateMin_ = nDate 
			If nDate  > DateMax_ Then DateMax_ = nDate
		End If
	End Sub

	Private Sub Update_
	'	Dim nYears, nDensity
	'	nYears = Year(DateMax_) - Year(DateMin_)
	'	If nYears > 0 And Nodes_ > 0 Then
	'		nDensity=Nodes_ * 100 / nYears
	'		Unit_ = Int(Log(nDensity)/Log(10))+7
	'		Pixels_ = Round(((Log(nDensity)/Log(10))-Unit_ - 7) * 100, 0)
	'		If Pixels_ >= 50 Then Pixels_ = 200
	'		If Pixels_ < 50 Then Pixels_ = 100
	'	Else
			Unit_ = 8
			Pixels_ = 50
	'	End If
		IsUpdated_ = True
	End Sub	

	Public Function AddEvent(oType, oStart, oEnd,fYearOnly, strTitle, strDesc)

		Dim strStartDate, strEndDate, strEnd, strSep, strIcon, strImage, oBegin, oFinsh, strEvent, strLink, strColor, fIsCurrent

		strStartDate = StrFullDate(oStart)
		strEndDate = StrFullDate(oEnd)
		If strTitle = "" Or (strStartDate = "" And stEndDate = "") Then
			AddEvent = 0
			Exit Function
		End If
		strSep = " - "
		strEnd = ""
		strLink =""
		strIcon=""
		If IsObject(oEnd) Then
			Set oFinish = oEnd
		Else
			oFinish = oEnd
		End If
		fIsCurrent = False
		If IsObject(oType) Then
			strEvent = oType.Class
			fPrivate = isPrivate(oType)
			fPrivateFolder = Eval(Left(Report.FileOutput,g_nPrivateFolder)=g_strPrivateFolder)
			If (fPrivate And Not fPrivateFolder) Then
				 AddEvent = 0
				 Exit Function
			End If
			Select Case strEvent
			Case "Individual"
				strEvent = strEvent & "_" & oType.Gender.ID
				If strDesc <> "" Then strLink = ", 'link' : '" & oType.Href & "'"
				fIsCurrent = Not oType.IsDead
			Case "Family"
				strEvent = strEvent & "_" & oType.Parents(0).Gender.ID & oType.Parents(1).Gender.ID
				If strDesc <> "" Then strLink = ", 'link' : '" & oType.Href & "'"
				If strEndDate = "" Then
					fIsCurrent = oType.AreTogether
					If Not fIsCurrent Then
						If Not oType.Parents(0).IsDead = True Then
							strEndDate = StrFullDate(oType.Parents(1).Death.Date)
							Set oFinish = oType.Parents(1).Death.Date
						ElseIf Not oType.Parents(1).IsDead = True Then
							strEndDate = StrFullDate(oType.Parents(0).Death.Date)
							Set oFinish = oType.Parents(0).Death.Date
						ElseIf StrFullDate(oType.Parents(0).Death.Date) <> "" And StrFullDate(oType.Parents(1).Death.Date) <> "" Then
							If DateValue(StrFullDate(oType.Parents(0).Death.Date)) < DateValue(StrFullDate(oType.Parents(1).Death.Date)) Then
								strEndDate = StrFullDate(oType.Parents(0).Death.Date)
								Set oFinish = oType.Parents(0).Death.Date
							Else
								strEndDate = StrFullDate(oType.Parents(1).Death.Date)
								Set oFinish = oType.Parents(1).Death.Date
							End If
						End If
					End If
				End If
			Case "Occupation"
				fIsCurrent = oType.Termination.ID="StillWorking"
			Case "Education"
				fIsCurrent = oType.Termination.ID="StillAttending"
			End Select
		Else
			strEvent = oType
		End If
		
		strImage = Dic.Peek("Timeline" & strEvent)
		If strImage <> "" Then
			If strEndDate = strStartDate Then		' end only 'point' event so get special icon if available.
				strImage =Dic.Plurial("Timeline" & strEvent, 3)
				oBegin=""
				strEndDate = ""
			ElseIf strStartDate <> "" Then
				Set oBegin = oStart
			End If
			strIcon = Util.FormatString(", 'icon' : 'images/{}.gif'", strImage)
			strColor = Util.IfElse(g_TimelineShowDuration,", 'color' : '", ", 'textColor' : '") & Dic.PlurialCardinal("Timeline" & strEvent, 1) & "'"
		End If
		If strEndDate = "" And g_TimelineContemporary and fIsCurrent Then strEndDate = g_Today
		If strEndDate = "" Then
			strSep = ""
		Else
			strEnd = Util.FormatString(", '{}' : '{}', 'isDuration' : 'false'", Util.IfElse(g_TimelineShowDuration, "end", "finish"), StrEndDate)
		End If
		If strStartDate = "" Then
			strStartDate = strEndDate
			strEndDate = ""
			strSep = "< "
		End If
		Report.WriteLn
		Report.WriteFormatted "{} 'start' : '{}'{}, 'title' : '{&j} {}{}{}'{}{}{}{}{},", "{", StrStartDate, strEnd, strTitle, StrGnoDate(oBegin, fYearOnly), strSep, StrGnoDate(oFinish, fYearOnly), strIcon, strColor, strLink, strDesc, "}"

		Nodes_ = Nodes_ + 1
		IsUpdated_ = False
		CheckDate_ strStartDate
		CheckDate_ strEndDate
		AddEvent = 1
	End Function

	Function AddHeader(Inline)
		If Inline Then
			Report.WriteLn "<script src=""timeline/timeline-api.js"" type=""text/javascript""></script>"
			Report.WriteLn "<script>"
			Report.WriteLn "var tl, tlParam = new Object();"
			Report.WriteFormattedLn "tlParam.unit = 8; tlParam.pixels=70; tlParam.duration = {}", LCase(g_TimelineShowDuration & "")
			Report.WriteFormattedLn "tlParam.nowTag = ' {&j}';", Dic("TimelineNowTag")
			Report.WriteFormattedLn "tlParam.wrapEvents = {};", LCase(g_TimelineWrapEvents)
			Report.Write "tlParam.json0 = "
		End If
		Report.WriteLn "{"
		Report.WriteLn "'events' : ["
	End function

	Function AddTrailer(Inline, strTitle)
		Dim nDateNoteStart, nDateNoteEnd, nDate
		If Not Inline Then
			On Error Resume Next
			nDateNoteStart = DateAdd("d",1, DateMax_)
			If Err.Number > 0 Then nDateNoteStart = DateMax_
			nDateNoteEnd   = DateAdd("yyyy",50, DateMax_)
			If Err.Number > 0 Then nDateNoteEnd = DateMax_
			nDate   = DateAdd("yyyy",-50, DateMax_)
			If Err.Number > 0 Then nDate = DateMax_
			On Error Goto 0
			Report.WriteFormattedLn "{}'title' : '{&j}', 'start' : '{&j} {&j} {&j}', 'end' : '{&j} {&j} {&j}', 'textColor' : 'black', 'color' : 'white', 'isDuration' : 'false', 'icon' : 'images/info.gif', 'description' : '{&j}'{}],",_
			 	"{", Dic("TimelineHelp"), _
				Day(nDateNoteStart), MonthName(Month(nDateNoteStart),True), Year(nDateNoteStart), _
				Day(nDateNoteEnd), MonthName(Month(nDateNoteEnd),True), Year(nDateNoteEnd), _
				Dic("TimelineHelpDetails"), "}"
			Report.WriteFormattedLn "'nowTag' : ' {&j}',", Dic("TimelineNowTag")
			Report.WriteFormattedLn "'subtitle': '{&j}',", strTitle
			Report.WriteFormattedLn "'date' : '{} {} {}'{}", Day(nDate), MonthName(Month(nDate),True), Year(nDate), "}"
		Else
			On Error Resume Next
			nDate   = DateAdd("yyyy",-10, DateMin_)
			If Err.Number > 0 Then nDate = DateMin_
			On Error Goto 0
			Report.BufferLength = Report.BufferLength - 1 ' remove last comma
			Report.WriteLn "]};"
			Report.WriteFormattedLn "tlParam.date = '{} {} {}';", Day(nDate), MonthName(Month(nDate),True), Year(nDate)
			Report.WriteLn "</script>"
		End If
	End Function

	
End Class
