' Generic utility routines that can be used anywhere.
' The routines in this files are language independent.
'
' HISTORY
' Aug-2005	GenoPro			Creation


'===========================================================
' The global object g_collFootnotes is used to maintain a list of unique footnotes
' to be displayed at the bottom of the page
Dim g_collFootnotes
' declare other global variables
Dim g_cxPictureSizeLarge, g_cyPictureSizeLarge, g_cxPictureSizeSmall, g_cyPictureSizeSmall, g_cxyPicturePadding
Dim g_fHidePictureName, g_fHideFamilyDetails, g_fCollapseNotes, g_fCollapseReferences, g_fHideNameTreeIndex
Dim g_oGenoMapSuffix, g_fUseTreeIndexes, g_fHideOtherRelationships, g_fJoinPlaceNames, g_fJoinSourceCitationNames
Dim g_cTocExpand, g_strPictureSlider, g_fUsePictureThumbnails, g_fUsePictureId, g_fShowPictureDetails
Dim g_fGoogleMaps, g_strGoogleMapsApiKey, g_strGoogleMapsZoom, g_fGoogleMapsLink, g_fGoogleMapsOverview, g_strGoogleMapsType
Dim g_cxGoogleMapsSmall, g_cyGoogleMapsSmall, g_cxGoogleMapsLarge, g_cyGoogleMapsLarge
Dim g_fSvgExpandFrame, g_fSvgZoomExtent, g_Calendar
Dim g_Timelines, g_TimelineMinEventsIndividual, g_TimelineMinEventsFamily, g_TimelineShowDuration, g_TimelineContemporary, g_TimelineWrapEvents, g_Today
Dim g_StyleSheet, g_RegEx, g_RegEx_PPN, g_RegEx_LPN, g_RegEx_CDS, g_eSpace, g_UID
Dim g_oPicIndex, g_oPicMaps, g_oGlobal, g_oDicRepGen, g_oDicCache, g_NameTags, g_NameDics, g_HtmlLang, g_LangShowOthers, strTemp

Dim g_strBaseUrl, g_strPrivateFolder, g_nPrivateFolder
Dim g_fDebug

' Initialize the global variables required to display individuals, families and pictures
' Those global variables begin by "g_" and are used by the routines found in multiple files.
Sub InitGlobalVariables

	Dim arrGeneralSettings, arrPictureSettings, arrTimelineSettings, arrSvgSettings, arrMapSettings

	g_NameTags = Session("NameTags")	'Array of tag names for Name with item 0=Full, 1=Formal, 2=KnownAs 3=Short
'	g_NameDics = Session("NameDics")	'Array of NameDictionary LookupTable objects with item 0=To, 1=Base, 2=Possessive 3=Locative 

	arrGeneralSettings = Session("GeneralSettings")

	g_Today = arrGeneralSettings(0)

'	Create array of regular expressions for possessive proper noun conversion (see StrPossessiveProperNoun function in Lang.vbs)
	g_RegEx_PPN = arrGeneralSettings(1)
'	Create array of regular expressions for Place preposition exceptions e.g. French au Le Mans => au Mans
	g_RegEx_LPN = arrGeneralSettings(2)
'	Create array of regular expressions for Date Span phrase conversion e.g. French jusqu'en 12 mai 1968 => jusqu'au 12 mai 1968
	g_RegEx_CDS = arrGeneralSettings(16)

'	Create a general use RegExp object
	Set g_RegEx = arrGeneralSettings(3)
	Set g_eSpace = arrGeneralSettings(4)

	g_UID = 0

	Set g_oGlobal 		= arrGeneralSettings(14)
	Set g_oDicRepGen 	= arrGeneralSettings(17)

	g_fUseTreeIndexes 		= arrGeneralSettings(5)
	g_fHideFamilyDetails 		= arrGeneralSettings(6)
	g_fHideNameTreeIndex 		= arrGeneralSettings(7)
	g_fJoinPlaceNames 		= arrGeneralSettings(8)
	g_fJoinSourceCitationNames 	= arrGeneralSettings(9)
	g_fCollapseNotes 		= arrGeneralSettings(10)
	g_fCollapseReferences 		= arrGeneralSettings(11)
	g_cTocExpand 			= arrGeneralSettings(12)
	g_StyleSheet 			= arrGeneralSettings(13)
	g_HtmlLang 			= arrGeneralSettings(15)
	g_LangShowOthers		= arrGeneralSettings(18)
	g_Calendar			= arrGeneralSettings(19)
	arrPictureSettings = Session("PictureSettings")

	g_cxPictureSizeLarge 	= arrPictureSettings(0)
	g_cyPictureSizeLarge 	= arrPictureSettings(1)
	g_cxPictureSizeSmall 	= arrPictureSettings(2)
	g_cyPictureSizeSmall 	= arrPictureSettings(3)
	g_cxyPicturePadding 	= arrPictureSettings(4)
	g_fHidePictureName 	= arrPictureSettings(5)
	g_fShowPictureDetails 	= arrPictureSettings(6)
	g_strPictureSlider 	= arrPictureSettings(7)
	g_fUsePictureThumbnails = arrPictureSettings(8)
	g_fUsePictureId 	= arrPictureSettings(9)

	arrMapSettings = Session("MapSettings")

	g_strGoogleMapsApiKey 	= arrMapSettings(0)
	g_fGoogleMaps 		= arrMapSettings(1)
	g_fGoogleMapsLink 	= arrMapSettings(2)
	g_fGoogleMapsOverview 	= arrMapSettings(3)
	g_strGoogleMapsZoom 	= arrMapSettings(4)
	g_strGoogleMapsType 	= arrMapSettings(5)
	g_cxGoogleMapsSmall  	= arrMapSettings(6)
	g_cyGoogleMapsSmall 	= arrMapSettings(7)
	g_cxGoogleMapsLarge  	= arrMapSettings(8)
	g_cyGoogleMapsLarge 	= arrMapSettings(9)

	arrSvgSettings = Session("SvgSettings")

	g_fSvgExpandFrame 	= arrSvgSettings(0)
	g_fSvgZoomExtent 	= arrSvgSettings(1)

	arrTimelineSettings = Session("TimelineSettings")

	g_Timelines 			= arrTimelineSettings(0)
	g_TimelineMinEventsIndividual 	= arrTimelineSettings(1)
	g_TimelineMinEventsFamily 	= arrTimelineSettings(2)
	g_TimelineShowDuration 		= arrTimelineSettings(3)
	g_TimelineContemporary 		= arrTimelineSettings(4)
	g_TimelineWrapEvents 		= arrTimelineSettings(5)

	' Save the base URL
	g_strBaseUrl = ReportGenerator.PathOutputHttp
	If g_strBaseUrl = "" Then g_strBaseUrl = "file:///" & Replace(ReportGenerator.PathOutput,"\","/")
	g_strPrivateFolder = "private/"
	g_nPrivateFolder = Len(g_strPrivateFolder)
	g_fDebug = False

	Set g_oGenoMapSuffix = Session("oGenoMapSuffix")

	Set g_oPicIndex = Session("oPicIndex")
	Set g_oPicMaps = Session("oPicMaps")

	Set g_oDicCache = Session("DicCache")
	
	' Create an empty collection to keep all the footnotes on the generated page
	Set g_collFootnotes = Util.NewGenoCollection()

End Sub

Sub WriteHtmlButtonToggle(style)
	Select Case style
	Case "Notes"
		Report.WriteFormattedLn "<img src='images/{}.jpg' class='buttonicon2' name='toggle' onclick='javascript:ToggleTree(this.name,"""");' alt='{1} {2}' title='{1} {2}'/>", Util.IfElse(g_fCollapseNotes,"expand","collapse"), Dic("TocExpandCollapseAll"), Dic(style)
	Case "References", "OtherDetails"
		Report.WriteFormattedLn "<img src='images/{}2.jpg' class='buttonicon2' name='toggle2' onclick='javascript:ToggleTree(this.name,""2"");' alt='{1} {2}' title='{1} {2}'/>", Util.IfElse(g_fCollapseReferences,"expand","collapse"), Dic("TocExpandCollapseAll"), Dic(style)
	Case "Entries"
		Report.WriteFormattedLn "<div class='buttontoc'><img src='images/{}2.jpg' class='buttonicon2' name='toggle2' onclick='javascript:ToggleTree(this.name,""2"");' alt='{1} {2}' title='{1} {2}'/></div>", Util.IfElse(fTreeOpen,"collapse","expand"), Dic("TocExpandCollapseAll"), Dic(style)
	Case "HidePopUp"  ' close 'popup' frame
		Report.WriteFormattedLn "<img src='images/close24.gif' class='buttonicon2' onclick='javascript:hidePopUpFrame(event);' alt='{0}' title='{0}'/>", Dic("AltHidePopUpFrame")
	End Select
End Sub

' Write the HTML code to display all the pictures of an individual, family or place
Sub WriteHtmlPictures(i, cxWidthMax, cyHeightLimit, cxyPadding, strAlign, strHeading, fNoName)
	Dim p, pic
	Set p = i.Pictures.Primary	' Get the primary picture of the individual or family	
	' Get the dimension of the picture.  This will load the picture if not already loaded
	If p.PictureDimension <> "" And CustomTag(p, "_Exclude") <> "Y" Then    
		Dim strId, strDimension,  cyHeightMax, cyHeight
		strId = i.ID
		Report.WriteFormattedLn "{}<div id='idPVp_{}'>", strHeading, strId
	'	find tallest picture
		For Each pic in i.Pictures
			strDimension = pic.PictureDimension(cxWidthMax & "x" & cyHeightLimit)
			cyHeight = Util.GetHeight(strDimension)
			If cyHeight > cyHeightMax Then cyHeightMax = cyHeight
		Next
		WriteHtmlPicture p, cxWidthMax, cyHeightMax, cxyPadding, strAlign, cxWidthMax, cyHeightLimit
		Report.Write "</div>"
		WriteHtmlNamePicture i, p

		If (i.Pictures.Count > 1) Then
			' Generate the code to create a slide show of pictures
			WriteHtmlButtonPV strId, "Play"
			WriteHtmlButtonPV strId, "Pause"
			WriteHtmlButtonPV strId, "Prev"
			WriteHtmlButtonPV strId, "Next"
			Report.WriteFormattedLn "<img id='idPVslider_{2}' src='images/slider.gif' style='position:relative;' width='30' height='16' alt='{0}' title='{0}'/>" & _
					"<img onmousemove='sliderMouseMove(event);' onmousedown='sliderMouseDown(event);' onmouseout='sliderMouseUpOut(event);' onmouseup='sliderMouseUpOut(event);' " & _
						"style='position:relative;left:{1}px;' src='images/knob.gif' width='9' height='15' alt='{0}' title='{0}'/>", Dic("PV_Speed"), g_strPictureSlider, strId
			Report.WriteFormattedLn "<select class='hide' id='idPVs_{0}' onchange=""PV_PickCore('{0}', 0);"">", strId
			For Each pic In i.Pictures
				' Load the picture and update its cache if necessary
				If pic.PictureDimension <> "" And CustomTag(pic, "_Exclude") <> "Y" Then
					Dim strImg, strSelected
					strImg = StrHtmlPicture(pic, cxWidthMax, cyHeightMax, cxyPadding, strAlign, cxWidthMax, cyHeightLimit)
					strSelected = Util.IfElse(pic.ID <> p.ID, "", " selected=""selected""")
					If g_fShowPictureDetails Then
						Report.WriteFormattedLn "<option{0} class='hide' value='{1&t}{5&t}{2&t}{5&t}{3&t}{5&t}{4&t}' ></option>", _
							strSelected, strImg, Util.IfElse(fNoName, StrHtmlHyperlink(pic), ""), Util.HtmlEncode(LanguageDictionary.FormatPhrase("PhPictureDetails", Util.IfElse(fNoName, "", StrHtmlTag(Trim(StrParseText(pic.Name)),"strong")), pic.Date.ToStringNarrative, pic.Place.Session("HlinkLocative"), pic.Source.Session("Hlink"))), StrParseText(pic.Description), chr(31)
					Else
						Report.WriteFormattedLn "<option{0} class='hide' value='{1&t}{3&t}{2&t}' ></option>", _
							strSelected, strImg, StrHtmlHyperlink(pic), chr(31)
					End If
				End If
			Next
			Report.WriteBr "</select>"
		End If
	End If
End Sub

Sub WriteHtmlPicturesLarge(i, strAlign, strHeading, fNoName)
	WriteHtmlPictures i, g_cxPictureSizeLarge, g_cyPictureSizeLarge, g_cxyPicturePadding, strAlign, strHeading, fNoName
End Sub

Sub WriteHtmlPicturesSmall(i, strAlign, fNoName)
	WriteHtmlPictures i, g_cxPictureSizeSmall, g_cyPictureSizeSmall, g_cxyPicturePadding, strAlign, "", fNoName
End Sub

Sub WriteHtmlPictureSmall(p, strAlign)
	WriteHtmlPicture p, g_cxPictureSizeSmall, g_cyPictureSizeSmall, g_cxyPicturePadding, strAlign, g_cxPictureSizeSmall, g_cyPictureSizeSmall
End Sub

Sub WriteHtmlPicture(p, cxWidthMax, cyHeightMax, cxyPadding, strAlign, cxWidthLimit, cyHeightLimit)	
	Dim strDimension, cxWidth, cyHeight, cxMargin, cyMargin, cxMarginL, cxMarginR, strAttributesHTML, strFloat, strThumbnail, i, strAreaMap

	If CustomTag(p, "_Exclude") <> "Y" Then
		strThumbnail = p.Path.Report
		If g_fUsePictureThumbnails Then
			i = InstrRev(strThumbnail, "/")
			strThumbnail = "thumbnails/" & mid(strThumbnail,i+1)
		End If
		strDimension = p.PictureDimension(cxWidthMax & "x" & cyHeightMax)
		cxWidth = Util.GetWidth(strDimension)
		cyHeight = Util.GetHeight(strDimension)

		cxMargin = (cxWidthMax - cxWidth) \ 2
		If (cxMargin < 0) Then cxMargin = 0
		cyMargin = (cyHeightMax - cyHeight) \ 2
		If (cyMargin < 0) Then cyMargin = 0
		strFloat=""
		cxMarginL = cxMargin
		If (strAlign = "right") Then cxMarginL = cxMarginL + cxyPadding
		cxMarginR = cxMargin
		If (strAlign = "left") Then
			cxMarginR = cxMarginR + cxyPadding
		End If
		strAttributesHTML = Util.FormatString(" width='{}px' height='{}px' class='pic{}' style='margin:{}px {}px {}px {}px;'", cxWidth, cyHeight, strAlign, cyMargin, cxMarginR, cyMargin, cxMarginL)
		strAreaMap = CustomTag(p, "_AreaMap")
		If strAreaMap = "" Then
			Report.WriteFormattedLn "<img src='{}'{} onclick='viewPic(""{&j}"")' alt='{&t}' title='{3&t}'/>", strThumbnail, strAttributesHTML, p.Path.report, Util.FormatPhrase(Dic("PhPictureTooltip"), "", p.Date.ToStringNarrative, p.Place.Session("Locative"), StrParseText(p.Source))
		Else
			Report.WriteFormattedLn "<a href='picture-{}.htm' onclick='javascript:showPopUpFrame("""");' target='popup' title='{&t}'><img src='{}'{} title='{1&t}' alt='{&t}'/></a>", p.ID, Dic("PictureDetailsTip"), strThumbnail, strAttributesHTML, Util.FormatPhrase(Dic("PhPictureTooltip"), "", p.Date.ToStringNarrative, p.Place.Session("Locative"), StrParseText(p.Source))
		End If
	End If
End Sub

Sub WriteHtmlNamePicture(o, p)
	Dim strId
	strId = o.ID
	If Not g_fHidePictureName Then
		Report.WriteFormattedLn "<div class='caption' id='idPVn_{}'>{}</div>", strId, StrHtmlHyperlink(p)
	End If
End Sub

Function StrFullDate(xDate)

' Make a complete date (dd mmm yyyy) from a either a GenoDate object or a (partial) date string by adding month (Jan) and/or day (01)

Dim strMonth, oDate, nMonth, nDay, strDate, nDate

If IsObject(xDate) Then
	Set oDate = xDate
	On Error Resume Next
	If IsObject(xDate.Date) Then Set oDate = xDate.Date	' check if parent of Date object
        Err.Clear
	strDate = Replace(oDate.ToString(""),"th,","")
	strDate = Replace(strDate,"st,","")
	strDate = Replace(strDate,"nd,","")
	strDate = Replace(strDate,"rd,","")
	
	If IsDate(strDate) Then
		nDate = CDate(strDate)
		StrFullDate = Day(nDate) & " " & MonthName(Month(nDate), True) & " " & Year(nDate)
		Exit Function
	End If
	On Error Goto 0
	If oDate.Year <> "" Then
		nMonth = oDate.NMonth
		If IsNumeric(nMonth) Then
			If nMonth > 0 And nMonth < 13 Then
				strMonth = MonthName(nMonth, True)
			Else
				strMonth = MonthName(1, True)
			End If
		Else
			strMonth = MonthName(1, True)
		End If
		nDay = oDate.NDay
		If IsNumeric(nDay) Then
			strDate = Util.IfElse(nDay > 0 And nDay < 32, nDay, "01") & " " & strMonth & " " & oDate.Year
			StrFullDate = Util.IfElse(IsDate(strDate), strDate, "")
		Else
			strDate = "01 " & strMonth & " " & oDate.Year
			StrFullDate = Util.IfElse(IsDate(strDate), strDate, "")
		End If
	Else
		StrFullDate = ""
	End If
Else
	StrFullDate = ""
End If
End Function

Function StrGnoDate(xDate, fYearOnly)
Dim oDate

If IsObject(xDate) Then
	Set oDate = xDate
	On Error Resume Next
	If IsObject(xDate.Date) Then Set oDate = xDate.Date	' check if parent of Date object
        Err.Clear
	On Error Goto 0
	If fYearOnly Then
		StrGnoDate = oDate.ToString("[|~|<|>]yyyy")
	Else
		StrGnoDate = oDate.Approximation & Trim(oDate.ToString("dd MMM yyyy"))
	End If	
Else
	StrGnoDate = ""
End If

End Function

' Output Html Content-Language e.g. "en-us" "fr" etc.
Sub WriteHtmlLang()
	Report.Write g_HtmlLang
End Sub

Sub WriteHtmlExtraNarrative(obj)
	Dim strNarrative
	strNarrative = CustomTag(obj, "_Narrative")
	If strNarrative <> "" Then
		Report.WriteFormattedLn "<div>{}</div>", StrFormatText(obj, strNarrative)
	End If
End Sub

' Same as WriteHtmlPicture() however returns a string containing the HTML code from what should be written to the output buffer
Function StrHtmlPicture(p, cxWidthMax, cyHeightMax, cxyPadding, strAlign, cxWidthLimit, cyHeightLimit)
	Dim cchBuffer
	cchBuffer = Report.BufferLength
	WriteHtmlPicture p, cxWidthMax, cyHeightMax, cxyPadding, strAlign, cxWidthLimit, cyHeightLimit
	StrHtmlPicture = Report.Buffer(cchBuffer)	' Get the text from the output buffer
	Report.BufferLength = cchBuffer	' Truncate the buffer to its original length
End Function


' Write the HTML code to generate a button (Play, Pause, Next, Prev) of the Picture Viewer (PV).
Sub WriteHtmlButtonPV(strId, strVerb)
	Report.WriteFormattedLn "<a href=""JavaScript:PV_{1}('{0}');"" {2}><img src='images/PV_{1}.gif' border='0' alt='{3}' title='{3}'/></a>", strId, strVerb, StrMouseOver(Dic("PV_" & strVerb)), Dic("PV_" & strVerb)
End Sub


' Return a string containing the HTML code to display the gender of the individual.
Function StrHtmlImgGender(i)
	StrHtmlImgGender = Util.FormatString("<img src='images/gender_{}.gif' class='icon' alt='{&t}' title='{1&t}' /> ", i.Gender.Id, i.Gender)
End Function

Function StrHtmlImgFamily(f)
	Dim strGender0, strGenders
	strGenders = "MF"
	strGender0 = f.Parents(0).Gender.ID
	If (strGender0 = f.Parents(1).Gender.ID) Then
		' Same-sex couples
		Select Case strGender0
			Case "M"
				strGenders = "MM"
			case "F"
				strGenders = "FF"
		End Select
	End If
	' strGenders = ""	' Enable this line if you want a generic icon for a family
	StrHtmlImgFamily = Util.FormatString("<img src='images/family_{}.gif' class='icon' alt='{}' title='{1}'/> ", strGenders, Dic("Family"))
End Function

Function StrHtmlImgPhoto(obj)
	Select Case obj.Class
	Case "Picture"
		fPrivateFolder = Eval(Left(Report.FileOutput,g_nPrivateFolder)=g_strPrivateFolder)
		if fPrivateFolder Then strHref = g_strPrivateFolder & "pictures.htm" Else strHref = "pictures.htm"
		StrHtmlImgPhoto = Util.FormatString("<img src='images/space.gif' width='16' alt=''/>&nbsp;<a href='{}#{}'><img src='images/photo.gif' class='icon' alt='' title='' />&nbsp;{&t}</a>",strHref, _
				obj.ID, Util.IfElse(Trim(obj.Name) <> "", Trim(obj.Name), "(" & obj.ID &")"))
	Case Else
		cPictures = obj.Pictures.Count
		If (cPictures > 0) Then
			StrHtmlImgPhoto = Util.FormatString("&nbsp;<a href='{}'><img src='images/photo.gif' class='icon' alt='{}' title='{1}' /></a>", _
				obj.Href, Dic.PlurialCount("Picture", cPictures))
		End If
	End Select
End Function

Function StrHtmlImgPhotoLink(i, target)
	cPictures = i.Pictures.Count
	If (cPictures > 0) Then
		StrHtmlImgPhotoLink = Util.FormatString("&nbsp;<a href='{}#{}'><img src='images/photo.gif' class='icon' alt='{}' title='{2}' /></a>", _
			target, i.ID, Dic.PlurialCount("Picture", cPictures))
	End If
End Function

' Link to the .gno file if present in the report
Function StrHtmlImgFileGno(obj)
	Dim strName
	strFileFamilyTreeGno = ReportGenerator.ExtraFiles("FamilyTree.gno")
	If (strFileFamilyTreeGno <> "") Then
		If obj.Class="Individual" Then
			strName = obj.Session("NameFull")
		Else
			strName = obj.Name
		End If
		StrHtmlImgFileGno = Util.FormatString(" <a href='{}?id={}'><img src='images/gno.gif' class='icon' alt='{&t}' title='{2&t}'/> </a> ", strFileFamilyTreeGno, obj.Id, Dic.FormatString("FmtAltViewInGnoFile", strName))
	End If
End Function

Function StrHtmlImgFileSvg(obj)
	Dim fFlag, strFileGenoMap, xyTopRight, xyTopLeft, xyStartRight, xyStartLeft, xTopCenter, pos
	fFlag = ReportGenerator.NegateAxisY
	ReportGenerator.NegateAxisY = True
	fPrivateFolder = Eval(Left(Report.FileOutput,g_nPrivateFolder)=g_strPrivateFolder)
	If fPrivateFolder Then
		strFileGenoMap = obj.Position.GenoMap.Session("PathGenoMapPrivate")
	Else
		strFileGenoMap = obj.Position.GenoMap.Session("PathGenoMap")
	End If
	If (strFileGenoMap <> "") Then
		Select Case obj.Class
		Case "Individual"	
			StrHtmlImgFileSvg = Util.FormatString(" <a href='{}?x={},y={},highlight=true' target='popup'><img src='images/svg.gif' class='icon' alt='{&t}' title='{3&t}'/> </a> ", strFileGenoMap, obj.Position.x, obj.Position.y, Dic.FormatString("FmtAltViewInSvgFile", obj.Name))
		Case "Family"
			Set pos = obj.Position
			xyTopRight=split(pos.Top.Right,",")
			xyTopLeft=split(pos.Top.Left,",")
			xyStartRight=split(pos.Bottom.Right,",")
			xTopCenter=xyTopLeft(0)+ ( xyTopRight(0) - xyTopLeft(0) ) / 2
			If uBound(xyStartRight) > 0 Then	' bottom line present, so centre highlight on top of vertical line
				StrHtmlImgFileSvg = Util.FormatString(" <a href='{}?x={},y={},highlight=true' target='popup'><img src='images/svg.gif' class='icon' alt='{&t}' title='{3&t}' /> </a> ", strFileGenoMap, obj.Position.x, obj.Position.y, Dic.FormatString("FmtAltViewInSvgFile", obj.Name))
			Else					' centre highlight on mid-point of family relationship
				StrHtmlImgFileSvg = Util.FormatString(" <a href='{}?x={},y={},highlight=true' target='popup'><img src='images/svg.gif' class='icon' alt='{&t}' title='{3&t}' /> </a> ", strFileGenoMap, xTopCenter, xyTopRight(1), Dic.FormatString("FmtAltViewInSvgFile", obj.Name))
			End If
		End Select
	End If
	ReportGenerator.NegateAxisY = fFlag
End Function

Function StrHtmlImgTimeline(obj)
	Dim strDate, strData, strLocale, oDate, strAlt, collUnions, u
	strData = obj.Position.GenoMap.Session("TLData")
	If g_Timelines And strData <> "" Then
		strLocale=GetLocale
		SetLocale("en-gb")
		Select Case obj.Class
		Case "Individual"
			strDate = Util.FirstNonEmpty(StrFullDate(obj.Birth), StrFullDate(obj.Birth.Baptism), StrFullDate(obj.death), StrFullDate(obj.Death.Disposition))
			strAlt=Dic("AltTimelineImageInd")
		Case "Family"
			Set collUnions = obj.Unions.ToGenoCollection
			For Each u in collUnions
				strDate = Util.FirstNonEmpty(StrFullDate(u), StrFullDate(u.Divorce))
				If IsDate(strDate) Then Exit For
			Next
			strAlt=Dic("AltTimelineImageFam")
		End Select
		If IsDate(strDate) Then
			oDate=DateAdd("d",-1,strDate)
			StrHtmlImgTimeline = Util.FormatString(" <a href='timeline.htm?{},date={} {} {}' target='popup'><img src='images/timeline.gif' class='icon' alt='{&t}' title='{4&t}'/> </a> ", _
						  strData, Day(oDate), MonthName(Month(oDate),True), Year(oDate), strAlt)
		End If
		SetLocale(strLocale)
	End If
End Function

' Return individuals name if not blank otherwise if not null generate substitute text for unknown individual
Function StrNameNN(i)
Dim strName
strName = i.Session("NameFull")
If strName <> "" Then
	StrNameNN = strName
ElseIf not Util.IsNothing(i) Then
	StrNameNN = StrDicMFU("_NoName", i.Gender.ID)
Else
	StrNameNN = ""	
End If
End Function

' Like ToHtmlHyperlinkNN method except returns blank if Individual object is empty or nothing
Function StrHtmlHyperlinkNN(obj)
	Select Case obj.class
	Case "Individual"
		If obj.Name <> "" Then 
			StrHtmlHyperlinkNN = Replace(obj.ToHtmlHyperlink,">"," target='detail' onclick='javascript:hidePopUpFrame();' >",1,1)
			If isPrivate(obj) Then
				 StrHtmlHyperlinkNN = Replace(StrHtmlHyperlinkNN,"href=""","class=""private"" href=""" & g_strPrivateFolder,1,1)
			End If
		Else
			StrHtmlHyperlinkNN = Util.HtmlEncode(StrNameNN(obj))
		End If
	End Select
End Function

Function StrHtmlHyperlink(obj)
	Dim strName, arrLocative
	Select Case obj.Class
	Case "Individual"
		StrHtmlHyperlink = Replace(obj.ToHtmlHyperlink,">"," target='detail' onclick='javascript:hidePopUpFrame();' >",1,1)
		If isPrivate(obj) Then StrHtmlHyperlink = Replace(StrHtmlHyperlink,"href=""","class=""private"" href=""" & g_strPrivateFolder,1,1)
	Case "Family"
		StrHtmlHyperlink=Util.FormatString("<a href='{0}' onclick='javascript:hidePopUpFrame("""");' target='detail'>{1&t}</a>", obj.Href, obj.Session("Name"))
	Case "Place"
		arrLocative = Split(Replace(obj.Session("LocativeRaw"),"]","["),"[") ' break into preposition (if any), name & postpostion(if any)
		StrHtmlHyperlink=Util.FormatString("{0}<a href='place-{1}.htm' onclick='javascript:showPopUpFrame("""");' target='popup'>{2&t}</a>{3}", arrLocative(0), obj.ID, arrLocative(1), arrLocative(2))
	Case "Picture"
		StrHtmlHyperlink=Util.FormatString("<a href='picture-{1}.htm' onclick='javascript:showPopUpFrame("""");' target='popup' title='{2&t}'>{0&t}</a>", Util.IfElse(g_fUsePictureId, obj.ID, Util.FirstNonEmpty(Trim(StrParseText(obj.Name)), Dic("PictureDetails"))), obj.ID, Dic("PictureDetailsTip"))
	Case "SourceCitation"
		StrHtmlHyperlink=Util.FormatString(" <a href='source-{1}.htm' onclick='javascript:showPopUpFrame("""");' target='popup'>{0&t}</a>", JoinSourceCitationNames(obj, obj.title, true), obj.ID)
	Case Else
			StrHtmlHyperlink = ""
	End Select
End Function

Function StrHtmlHyperlinkTag(obj, strTag)
	Select Case obj.Class
	Case "Individual"
		StrHtmlHyperlinkTag = Replace(obj.ToHtmlHyperlink,">" & obj.Name & "<"," target='detail' onclick='javascript:hidePopUpFrame();' >" & Util.HtmlEncode(obj.TagValue(strTag)) & "<",1,1)
	End Select
End Function
	

Function StrHtmlHyperlinkPlace(obj)
' Like StrHtmlHyperlink except no preposition included
	Dim arrLocative
	Select Case obj.Class
	Case "Place"
		arrLocative = Split(Replace(obj.Session("LocativeRaw"),"]","["),"[") ' break into preposition (if any), name & postpostion(if any)
		StrHtmlHyperlinkPlace=Util.FormatString(" <a href='place-{1}.htm' onclick='javascript:showPopUpFrame("""");' target='popup'>{0&t}</a>", arrLocative(1), obj.ID)
	Case Else
			StrHtmlHyperlinkPlace = ""
	End Select
End Function

Function StrHtmlTag(strValue, strTag)
	If strValue <> "" Then
		StrHtmlTag = "<" & strTag & ">" & strValue & "</" & strTag & ">"
	End If
End Function

Function StrJsonDescription(strData)
	StrJsonDescription= Util.FormatPhrase(Dic("PhTL_Description"),Util.FormatString("{&j}", Util.StrFirstCharUCase(strData)))
End Function

' Generate the code to display text at the bottom of the status bar when the mouse is over a link or an image
Function StrMouseOver(s) 
	StrMouseOver = Util.FormatString("onmouseover=""return ss('{&j}')"" onmouseout=""cs()"" title='{0&t}'", s)
End Function

Function WriteFamilyEvents (oTLInfo, f, strTitle, fYearOnly, fChildren)
	Dim collUnions, u, d, cchBegin, cchStart, strYear, oStart, oEnd, collChildren, nEvent
	Dim oRepertoryNonBio
	Set oRepertoryNonBio = Session("oRepertoryNonBio")
	Set collUnions = f.Unions.ToGenoCollection
	For Each u in collUnions
		Set d = u.Divorce
		cchStart = Report.BufferLength
		If (u.Date <> "") Then Set oStart = u.Date
		If (d.Date <> "") Then Set oEnd = d.Date
		If IsObject(oStart) Then
			If IsObject(oEnd) Then
				oTLInfo.AddEvent f, oStart, oEnd, fYearOnly, strTitle, _
						StrJsonDescription(Util.FormatPhrase(Dic("PhTL_Union"), Dic.Plurial("PnP_", 2), u.Type, u.Date.ToStringNarrative, u.Place.Session("Locative"), u.Officiator.Title, u.Officiator, u.Witnesses, StrVerb("ToBe", f.AreTogether, False, "2", "")) & " " & _
								Util.FormatPhrase(Dic("PhTL_Divorce"), u.IsAnnulled, d.Date.ToStringNarrative, d.Place.Session("Locative"), d.RequestedBy.ID, _
									 d.RequestedBy, d.Attorney.Husband, d.Attorney.Wife, d.Officiator))
			Else
				oTLInfo.AddEvent f, oStart, "", fYearOnly, strTitle, _
						StrJsonDescription(Util.FormatPhrase(Dic("PhTL_Union"), Dic.Plurial("PnP_", 2), u.Type, u.Date.ToStringNarrative, u.Place.Session("Locative"), u.Officiator.Title, u.Officiator, u.Witnesses, StrVerb("ToBe", f.AreTogether, False, "2", "")))
			End If
		End If
		If IsObject(oEnd) And Not IsObject(oStart) Then
				oTLInfo.AddEvent f, oEnd, oEnd, fYearOnly, strTitle & " " & Dic("DivorceAbbr"), _
						StrJsonDescription(Util.FormatPhrase(Dic("PhTL_Divorce"), u.IsAnnulled, d.Date.ToStringNarrative, d.Place.Session("Locative"), d.RequestedBy.ID, _
							 d.RequestedBy, d.Attorney.Husband, d.Attorney.Wife, d.Officiator))
		End If
	Next
	If fChildren Then
		Set collChildren = f.Children.ToGenoCollection
		For Each c in collChildren
			If Not c.IsAdopted = "Y" Then
				WriteIndividualEvents oTLInfo, c, Dic.LookupEx("Child_", c.Gender.ID) & " " & c.Name, False
			Else
				If oRepertoryNonBio.KeyCounter("I" & c.ID & "F" & f.ID) > 0 Then
					Set oLink = oRepertoryNonBio.Entry("I" & c.ID & "F" & f.ID).Object(0)
					WriteIndividualEvents oTLInfo, c, Dic.FormatString("TimelineAdopted", StrDicMFU("Pedigree" & oLink.PedigreeLink.ID,c.Gender.ID), Dic.LookupEx("Child_", c.Gender.ID), c.Name), False
					If oLink.Adoption.Date <> "" Then					
						oTLInfo.AddEvent "", oLink.Adoption, , fYearOnly, Dic("Pedigree" & oLink.PedigreeLink.ID & "Event"),""
					End If
				End If
			End If
		Next
	End If
End Function

Sub WriteHtmlAdditionalInformation(obj)
' Write details of this object's Custom Tags to the report
'
	Dim oCustomTagRepertory, oCustomTagDictionary, Layout, Layouts, i, j, cchBufferBegin, cchBufferStart, cchBufferNow
	Dim strCustomTagData, strCustomTagDesc, strPrivate, strTag, strFmtTemplate, Args()
	strPrivate = LanguageDictionary.Peek("Private")
	cchBufferBegin = Report.BufferLength
	Set oCustomTagRepertory = Session("oCustomTagRepertory")

	Report.WriteBr	"<div class='clearleft'><ul class='xT'>"
	Report.WriteFormattedLn "    <li class='xT2-{} xT-h' onclick='xTclk(event,""2"")'>", Util.IfElse(g_fCollapseReferences, "c", "o")
	Report.WriteFormattedLn "<a name='Additional Information'></a><h3 class='xT-i inline'>{&t}</h3><ul class='xT-h'>", Util.StrFirstCharUCase(Dic.FormatString("FmtAdditionalInformation", LCase(Dic(obj.Class))))

	If obj.Class = "Individual" Then ' List any External Hyperlink, Blood Type, Social or Emotional Relationships here
		cchBufferNow = Report.BufferLength
		If obj.Hyperlink <> "" Then Report.WritePhraseDic "PhExternalLink", Util.FormatString("<a href='{0}'>{0}</a>", obj.Hyperlink)
		Report.WritePhraseDic("PhBloodType"), obj.Name.short, obj.Birth.BloodType, obj.IsDead=false
		If Report.BufferLength > cchBufferNow Then ' some phrase written
			cchBufferBegin= -1	  ' indicate data present in Additional Information section
		End If
		cchBufferStart = Report.BufferLength
		Report.WriteLn "<br /><li class='xT2-o xT-h' onclick='xTclk(event,""2"")'>"
		Report.WriteFormattedLn "<span class='xT-i subhead bold'>{&t}</span><ul class='xT-h'><li>", Dic("Relationships")
		cchBufferNow = Report.BufferLength
		WriteHtmlRelationships obj
		If Report.BufferLength > cchBufferNow Then ' some relationships written
			cchBufferBegin = -1	  ' indicate data present in Additional Information section
			Report.WriteLn "</li></ul></li><div class='clearleft'></div>"
		Else 
			Report.BufferLength = cchBufferStart
		End If
	End If
	If oCustomTagRepertory.KeyCounter(obj.Class) > 0 Then ' Custom tags exist for this object
		Layouts = oCustomTagRepertory.Entry(obj.Class).Count
		Set oCustomTagDictionary = oCustomTagRepertory(obj.Class)
	End If

	For i = 1 to Layouts - 1

		Layout = oCustomTagRepertory.Entry(obj.Class).Object(i)
		cchBufferStart = Report.BufferLength


		' check if this Custom Tag Dialog Layout has an associated phrase in the Language Dictionary
		strFmtTemplate = LanguageDictionary.Peek("PhCT_" & Layout(0))

		If strFmtTemplate <> "" Then			' create a custom phrase
			Report.WriteLn "<br /><li class='xT2-o xT-h' onclick='xTclk(event,""2"")'>"
			Report.WriteFormattedLn "<span class='xT-i subhead bold'>{&t}</span><ul class='xT-h'><li>", Layout(1)
			ReDim Args(Ubound(Layout)+8)
			Args(0) = obj & ""  ' default property e.g. name
			Select Case obj.Class
			Case "Individual"
				Args(0) = obj.Name.short
				Args(1) = PnP(obj)
				Args(2) = PnR(obj)
				Args(3) = PnO(obj)
				Args(4) = Not obj.IsDead
			Case "Family"			
				Args(1) = Dic.Plurial("PnP_", 2)
				Args(2) = Dic("their")
				Args(3) = Dic("them")
				Args(4) = obj.AreTogether
			Case "Marriage"
				Args(1) = DDic.Plurial("PnP_", 2)
				Args(2) = Dic("their")
				Args(3) = Dic("them")
				Args(4) = Not obj.AreTogether
			Case Else
				Args(1) = Dic("it")
				Args(2) = Dic("its")
				Args(3) = Dic("it")
				Args(4) = True
			End Select
			' create fixed part of Report.WritePhrase statement. N.B. params 5 - 9 are reserved but not used at present
			strExecute = "Report.WritePhrase strFmtTemplate, Args(0), Args(1), Args(2), Args(3), " & Util.IfElse(Args(4),"True","False") & _
									 ","""", """", """", """", """""
			' now add Custom Tag contents as param 10 onwards.
			For j = 2 to Ubound(Layout)
				strTag = Layout(j)
				If strTag <> "" Then
					Args(j+3) = StrParseText(CustomTag(obj,strTag))
				End If
				strExecute = strExecute & ", Args(" & j+3 & ")"
			Next
			cchBufferNow = Report.BufferLength
			Execute strExecute
			If Report.BufferLength > cchBufferNow Then
				cchBufferStart = -1	  ' indicate at least one value present in this Custom Tag Dialog Layout
			End If

			Report.WriteLn "</li></ul></li>"
		Else						' no custom template 
								' so create a collapse/expand section with the
								' custom tags in a table.

			Report.WriteFormattedLn "<br /><li class='xT2-{} xT-h' onclick='xTclk(event,""2"")'>", Util.IfElse(g_fCollapseReferences, "c", "o")
			Report.WriteFormattedLn "<span class='xT-i subhead bold'>{&t}</span><ul class='xT-h'><li><table class='customtagtable'>", Layout(1)
			For j = 2 to Ubound(Layout)
				strTag = Layout(j)
				strCustomTagData = Util.IfElse(strTag <> "", CustomTag(obj,strTag), "")

				If strCustomTagData <> "" Then
					strCustomTagDesc = oCustomTagDictionary.KeyValue(strTag)
					Report.WriteFormattedLn "<tr><td>{&t}</td><td>{}</td></tr>",strCustomTagDesc, StrFormatText(obj, strCustomTagData)
					cchBufferStart = -1	  ' indicate at least one value present in this Custom Tag Dialog Layout
				End If
			Next

			Report.WriteLn "</table></li></ul></li>"
		End If

		If cchBufferStart > 0 Then ' no Custom Tags set in this Dialog Layout Section so remove phrase or table
			Report.BufferLength = cchBufferStart
		Else
			cchBufferBegin = -1 ' indicate at least one custom tag set
		End If
	Next
	Report.WriteLn "</ul></li></ul></div>"
	If cchBufferBegin > 0 Then	' no Custom tags present so remove the Additional Information section
		Report.BufferLength = cchBufferBegin
	Else
		g_ichReferencesStart = -1	' indicate at least one expand/collapse non-note item present
	End If
End Sub

Sub WriteHtmlRelationships(i)
	Dim strPnO, strPnp, strTitle, fAlive, fExtant, r, oRepertoryEntity, strConnection, strConnections, strName, strNameO
	strPnP = PnP(i)
	strPnO = Util.StrFirstCharUCase(PnO(i))

	Set oRepertoryEntity1 = Session("oRepertoryEntity1")
	Set oRepertoryEntity2 = Session("oRepertoryEntity2")

	If oRepertoryEntity1.KeyCounter(i.ID) > 0 Or _
		oRepertoryEntity2.KeyCounter(i.ID) > 0 Then
		If oRepertoryEntity1.KeyCounter(i.ID) > 0 Then
			Set oRepertoryEntity = oRepertoryEntity1.Entry(i.ID)
			strName = i.Session("NameShort")
			strNameO = strName
			For Each r In oRepertoryEntity
				Report.WriteLn "<div class='clearleft'>"
				If (r.Pictures.Count > 0) Then
					Report.WriteLn "<div class='floatleft aligncenter widthpaddedsmall'>"
					WriteHtmlPicturesSmall r, "left", g_fHidePictureName
					Report.WriteLn "</div>"
				End If
				WriteHtmlRelationship r, strName, strNameO, "", "", False, True
				WriteHtmlAdditionalInformation(r)
				WriteHtmlAnnotation r, Dic("AnnotationRelationship"), r.Comment
				strName = strPnP
				strNameO = strPnO
				Report.WriteLn "</div>"
			Next
		End If
		If oRepertoryEntity2.KeyCounter(i.ID) > 0 Then
			Set oRepertoryEntity = oRepertoryEntity2.Entry(i.ID)
			strName = i.Session("NameShort")
			strNameO = strName
			For Each r In oRepertoryEntity
				Report.WriteLn "<div class='clearleft'>"
				If (r.Pictures.Count > 0) Then
					Report.WriteLn "<div class='floatleft aligncenter widthpaddedsmall'>"
					WriteHtmlPicturesSmall r, "left", g_fHidePictureName
					Report.WriteLn "</div>"
				End If
				strConnection = ""
				If r.Class = "SocialRelationship" Then
					strConnection = r.Connection.ID
				Else
					strConnection = r.EmotionalLink.ID
				End If
				Select Case strConnection
				Case "Roommate", "LivesWith", "Neighbor", "Acquaintance", "Associate", "Know", "Relative", "WorkWith", "" ' two way relationship so keep individual as subject (i.e. switch)
					WriteHtmlRelationship r,  r.entity1.Session("HlinkNN"),"", strName, strNameO, True, True
				Case Else
					If strConnection = "" Then strConnection = " "
					Select Case Left(strConnection,3)
					Case "Abu", "Man", "Con", "Foc", "Fan", "Lim", "Jea"
						WriteHtmlRelationship r, "", "", strName, strNameO, False, True
					Case Else
						If r.Class = "EmotionalRelationship" Then
							WriteHtmlRelationship r,  r.Entity1.Session("HlinkNN"),"", strName, strNameO, True, True 
						Else 
							WriteHtmlRelationship r, "", "", strName, strNameO, False, True
						End If
					End Select
				End Select
				WriteHtmlAdditionalInformation(r)
				WriteHtmlAnnotation r, Dic("AnnotationRelationship"), r.Comment
				Report.WriteLn "</div>"
				strName = strPnP
				strNameO = strPnO
			Next
		End If
	End If
End Sub	

' Write the HTML code to display notes and comments for birth, death, education, occupation, etc.
Sub WriteHtmlAnnotation(obj, strAnnotationType, strAnnotationCommentFull)
	Dim strAnnotationComments, strAnnotationComment
	Dim strParsedComment, strParse, Match
	Dim stLink, strDisplay
	strAnnotationComments = split(strAnnotationCommentFull,Dic("Private"))
	If Ubound(strAnnotationComments) >= 0 Then strAnnotationComment = strAnnotationComments(0)
	Set strParse = new RegExp
	strParse.Pattern ="((http|https|ftp)://[%:;/!@=~&\$\-\.\+\*\(\)\,\?\w]+(\{[\x20-\x7c\x7e-\xff]+\})?)"
	strParse.Global=True
	strParse.IgnoreCase=True
	strComment = strAnnotationComment
	Set strParsedComment = strParse.Execute(strAnnotationComment)
	If strParsedComment.Count >0 Then
		nPos=1
		strAnnotationComment = ""
		For Each Match in strParsedComment
			Report.LogWarning "File " & Report.FileOutput & " contains URL: " & Match.Value
			n = Match.FirstIndex - nPos + 1
			strAnnotationComment =  strAnnotationComment & Util.HtmlEncode(Mid(strComment,nPos,n))
			If Right(Match.Value,1)="}" Then
				strSplit   = Split(Left(Match.Value,Match.Length-1),"{",-1,1)
				strLink    = Util.HrefEncode(strSplit(0))
				strDisplay = Util.HtmlEncode(strSplit(1))
			Else
				strLink    = Util.HrefEncode(Match.Value)
				strDisplay = Util.HtmlEncode(Match.Value)
			End If
			' HrefEncode does not escape out ampersands like it ought to, so do than now.
			strLink = Replace(strLink, "&", "&amp;", 1, -1, 1)
			strAnnotationComment = strAnnotationComment & _
				"<a href=""" & strLink & """ target=""_top"">" & strDisplay & "</a>"
			nPos = nPos + n + Match.Length
		Next
		strAnnotationComment = strAnnotationComment & Util.HtmlEncode(Mid(strComment,nPos))
	Else
		strAnnotationComment =  Util.HtmlEncode(strComment)
	End If
	If (strAnnotationComment <> "") Then
		g_ichNotesStart = -1	' Use a negative value to indicate the presence of an annotation
		Report.WriteFormattedLn	"<ul class='xT note'>" & vbNewline & _
				     	"  <li class='xT-{} xT-h' onclick='xTclk(event,"""")'>{&t}" & vbNewline & _
				     	"    <ul class='xT-n'>" & vbNewline & _
				     	"     <li class='xT-b xT-n'>{}" & vbNewline & _
				     	"     </li>" & vbNewline & _
				     	"    </ul>" & vbNewline & _
					"  </li>" & vbNewline & _
					"</ul>" & vbNewline, _
					Util.IfElse(g_fCollapseNotes, "c", "o"), strAnnotationType, strAnnotationComment
	End If
End Sub
' as above but get result as string
Function StrHtmlAnnotation(obj, strAnnotationType, strAnnotationCommentFull)
	Dim cchBuffer
	cchBuffer = Report.BufferLength
	WriteHtmlAnnotation obj, strAnnotationType, strAnnotationCommentFull
	StrHtmlAnnotation = Report.Buffer(cchBuffer)	' Get the text from the output buffer
	Report.BufferLength = cchBuffer	' Truncate the buffer to its original length
End Function

' Write the HTML code to display the comment of the primary picture (if present)
' If the picture does not have a description, the code must be written, otherwise
' the slideshow will abort by a script error
Sub WriteHtmlAnnotationPicture(strAnnotationType, obj, strAlign, nWidth )

	Dim p, strId, strClass, strDescription
	Set p = obj.Pictures.Primary
	If (Not Util.IsNothing(p)) Then
		strId = obj.ID
		strClass = "show"
		strDescription = StrFormatText(p, p.Description)
		If (strDescription = "") Then
			strDescription = "&#32;"
			strClass = "hide"
		Else
			g_ichNotesStart = -1	' Use a negative value to indicate the presence of an annotation
		End If
		Report.WriteFormattedLn "<ul id='idPVv_{}' class='xT {} note'>", strId, strClass
		Report.WriteFormattedLn "    <li class='xT-{} xT-h' onclick='xTclk(event,"""")'>{&t}", Util.IfElse(g_fCollapseNotes, "c", "o"), Dic.FormatString("FmtAnnotationPicture", strAnnotationType)
		Report.WriteFormattedLn "        <ul class='xT-n'><li id='idPVd_{}' class='xT-b xT-n'>{}</li></ul>", strId, strDescription
		Report.WriteLn          "    </li>"
		Report.WriteLn          "</ul>"
	End If
End Sub

' Write details associated with a primary picture with a specific HTML id so that it can be overwritten for each picture in a slideshow if required
Sub WriteHtmlDetailsPicture(obj, fNoName, fBr)
	Dim p, strId
	Set p = obj.Pictures.Primary	' Get the primary picture of the object
	If p.PictureDimension <> "" Then
		strId = obj.ID
		Report.WriteFormattedLn "<div class='caption' id='idPVc_{}'>{}</div>", strId, LanguageDictionary.FormatPhrase("PhPictureDetailsHtml", Util.IfElse(fNoName, "",StrHtmlTag(StrParseText(Trim(p.Name)),"strong")), p.Date.ToStringNarrative, p.Place.Session("HlinkLocative"), p.Source.Session("Hlink"))
	End If
End Sub

' Write a reference to a footnote item
' This routine requires the presence of a GenoCollection object named g_collFootnotes to store
' the unique footnotes.
Sub WriteHtmlFootnoteRef(oFootnote)
	If (Not Util.IsNothing(oFootnote)) Then
		Dim iFootnote		' Zero-based index representing the position where the footnote is found in the collection
		iFootnote = g_collFootnotes.AddUnique(oFootnote)
		Report.WriteFormatted "<sup><a href='#{0}' title='{}'>{0}</a>&nbsp;</sup>", iFootnote + 1, Dic("SourceFootnote")
	End If
End Sub

' Write a reference for two footnotes.  If both footnotes are identical,
' then write only a single footnote
Sub WriteHtmlFootnoteRef2(oFootnote1, oFootnote2)
'	If (Not Util.AreObjectsEqual(oFootnote1, oFootnote2)) Then
	If oFootnote1 <> oFootnote2 Then
		WriteHtmlFootnoteRef oFootnote1
	End If
	WriteHtmlFootnoteRef oFootnote2
End Sub

Sub WriteHtmlFootnoteRefs(oFootnotes)
	For Each oFootnote in oFootnotes.ToGenoCollection
		WriteHtmlFootnoteRef(oFootnote)
	Next
End Sub

' Write all the footnotes to the report
Sub WriteHtmlAllFootnotes(oSources)
Dim collSources
Set collSources = Util.NewGenoCollection()
If Not Util.IsNothing(OSources) Then collSources.Add(oSources.ToGenoCollection)
If (g_collFootnotes.Count > 0) Or (collSources.Count > 0) Then
		Report.WriteLn "<div class='footnote clearleft'><br />"
		If (g_collFootnotes.Count > 0) Then
			Dim iFootnote, oFootnote, strTitle, strSep, s
			iFootnote = 0
			For Each oFootnote In g_collFootnotes
				iFootnote = iFootnote + 1
				strTitle = StrParseText(Util.FirstNonEmpty(oFootnote.Subtitle, oFootnote.Description, oFootnote.QuotedText, Dic("SourceInformation")))
				If (strTitle <> "") Then
					strTitle = Util.FormatString(" title='{&t}'", strTitle)
				End If
				Report.WriteFormattedBr "<sup><a name='{0}'></a>{0} </sup> <a href='source-{&t}.htm' onclick='javascript:showPopUpFrame("""");' target='popup' {}><i>{&t}</i></a>", iFootnote, oFootnote.ID, strTitle, JoinSourceCitationNames(oFootnote, StrParseText(oFootnote.title), true)
				' remove referenced source from list
				collSources.Remove(oFootnote)
			Next
			g_collFootnotes.clear
		End If
		If collSources.Count > 0 Then ' write details of remaining source/citations
			Report.Write "<br\>" & Dic.Plurial("SourceCitation" & Util.IfElse(g_collFootnotes.Count > 0, "_Other",""), collSources.Count)
			strSep = ""
			For Each oFootnote in collSources
				strTitle = StrParseText(Util.FirstNonEmpty(oFootnote.Subtitle, oFootnote.Description, oFootnote.QuotedText, Dic("SourceInformation")))
				If (strTitle <> "") Then
					strTitle = Util.FormatString(" title='{&t}'", strTitle)
				End If
				Report.WriteFormatted strSep & " <a href='source-{&t}.htm' onclick='javascript:showPopUpFrame("""");' target='popup' {}><i>{&t}</i></a>", oFootnote.ID, strTitle, JoinSourceCitationNames(oFootnote, StrParseText(oFootnote.title), true)
				strSep = ","
			Next
		End If
		Report.WriteLn "</div>"
	End If
End Sub


' This method writes the HTML code to make sure the entire report is accessible from any page.
' Do not remove this safeguard; it may affect the navigation of the report.
' The text is written in English because it is very rare someone will actually read it.  This text is not
' the most eloquent English, however it contains a wealth of keywords for surfers to quickly find your
' genealogy report if published on the web.
' The text should be translated to include keywords in your language.
Sub WriteHtmlFramesetSafeguardK(s, k, o)
	Report.WriteLn "<div id='divFrameset' class='hide'> <hr /><p><br />"
	Dim strHref, strName, strClass, strLink
	strHref = "toc_individuals.htm"
	If (Not Util.IsNothing(o)) Then
		strClass = o.Class
		If (strClass = "Individual") Then
			strName = o.Name.Last
			k = ""
		ElseIf (strClass = "Family") Then
			strName =  o
			strHref = "toc_families.htm"
			k = ""
		End If
	End If	
	Report.WriteBr Util.FormatPhrase(Dic("FmtFramesetSafeguard"), strName, strHref, Session("Title"), strClass="Individual",  strClass="Family")
	Report.WriteT3Br "(", k, ")"
	strLink =  Replace(Dic.SearchKeywordHyperlink, "Learn how to build your family tree", Session("SKAltDefault"))
	Report.WriteFormatted "{}.</p><hr /><br /><p class='aligncenter'><small>{}</small></p></div>", strLink, Util.FormatString(Dic("FmtCopyright"), " 2007 GenoPro Inc.")
End Sub

Sub WriteHtmlFramesetSafeguard(s)
	WriteHtmlFramesetSafeguardK s, "", nothing
End Sub

Function WriteIndividualEvents (oTLInfo, i, strTitle, fYearOnly)
	Dim cchBegin, cchStart, oStart, oEnd, fLink, nEvent, strGender
	Dim b, ba, c, d, f
	cchStart = Report.BufferLength
	strGender = i.Gender.ID
	Set b = i.Birth
	Set ba = b.Baptism
	Set d = i.Death
	Set f = d.Funerals
	Set c = d.Cause
	fLink = (i.Hyperlink.Internal = "Y")
	If b.Date <> "" Then
		Set oStart = b.Date
	ElseIf ba.Date <> "" Then
		Set oStart = ba.Date
	End If
	If d.Date <> "" Then
		Set oEnd = d.Date
	ElseIf f.Date <> "" Then
		Set oEnd = f.Date
	End If
	If fLink Then
		If i.IndividualInternalHyperlink.ID <> "" Then
			 fLink = Not oLinks.Added(i.IndividualInternalHyperlink.ID)
		Else
			fLink = Not oLinks.Added(i.ID)
		End If
	End If
	If Not fLink And IsObject(oStart) Then
		If IsObject(oEnd) Then
			oTLInfo.AddEvent i, oStart, oEnd, fYearOnly, strTitle, _
					StrJsonDescription(Util.FormatPhrase(StrDicMFU("PhTL_Birth", strGender), PnP(i), b.Date.ToStringNarrative, b.Place.Session("Locative"), ba.Date.ToStringNarrative, _
								ba.Place.Session("Locative"), ba.Officiator.Title, ba.Officiator, (b.Place.ID = ba.Place.ID), _
								b.Doctor, b.PregnancyLength.Months,  b.PregnancyLength.Weeks, strPnR, b.CeremonyType, i.Session("NamePossessive")) & " " & _
							   Util.StrFirstCharUCase(Util.FormatPhrase(StrDicMFU("PhTL_Died", strGender), PnP(i), i.Death.Age.Years, i.Death.Age.Months, i.Death.Age.Days, d.Date.ToStringNarrative, d.Place.Session("Locative"), c, c.Description, i.Birth.Date.Approximation & i.Death.Date.Approximation)))
		Else
			oTLInfo.AddEvent i, oStart, , fYearOnly, strTitle, _
					StrJsonDescription(Util.FormatPhrase(StrDicMFU("PhTL_Birth", strGender), PnP(i), b.Date.ToStringNarrative, b.Place.Session("Locative"), ba.Date.ToStringNarrative, _
								ba.Place.Session("Locative"), ba.Officiator.Title, ba.Officiator, (b.Place.ID = ba.Place.ID), _
								b.Doctor, b.PregnancyLength.Months,  b.PregnancyLength.Weeks, strPnR, b.CeremonyType, i.Session("NamePossessive")))
		End If
	End If
	If Not fLink And IsObject(oEnd) And Not IsObject(oStart) Then
		oTLInfo.AddEvent i, oEnd, oEnd, fYearOnly, strTitle & " " & Dic("DiedAbbr"), _
			StrJsonDescription(Util.FormatPhrase(StrDicMFU("PhTL_Died", strGender), PnP(i), i.Death.Age.Years, i.Death.Age.Months, i.Death.Age.Days, d.Date.ToStringNarrative, d.Place.Session("Locative"), c, c.Description, i.Birth.Date.Approximation & i.Death.Date.Approximation))
	End If
End Function

' Write event details as a JSON array element for the MIT Simile Timeline 'widget'.

	
' Write the report description for the META tag.
' This routine is used by default.htm, header.htm and home.htm.
Sub WriteMetaDescriptionReport

	Report.WritePhraseDic "FmtMetaDescReport1", Session("Title"), Individuals.Count, Families.Count
	Report.WriteText " " & Dic("FmtMetaDescReport2") & " "

	Dim oStringDictionaryNames, iName, iNameLast, strSep
	Set oStringDictionaryNames = Session("oStringDictionaryNames")
	If (Not Util.IsNothing(oStringDictionaryNames)) Then
		iNameLast = oStringDictionaryNames.Count - 1
		If (iNameLast > 9) Then
			iNameLast = 9		' Keep only the first 10 families
		End If
		strSep = ""
		For iName = 0 To iNameLast
			Report.WriteText strSep & oStringDictionaryNames.Key(iName)
			strSep = ", "
		Next
	End If
	Report.WriteText "."
End Sub

' Write the report keywords for the META tag.
Sub WriteMetaKeywordsReport
	Report.Write Dic("FmtMetaKeyWordsReport")
End Sub

Function StrFormatText(obj, strText)
'
' Handles text 'processing instructions' embedded in Comment, Descriptions, Custom Tags etc.
'
	Dim strPart, strParts, strSubParts, strParams, strResult, i, strUID, strMode, strTemp
	If strText = "" or strText = "<?text?>" Then
		StrFormatText = ""
		Exit Function
	End If
	strMode = "<?text?>"
	strParts = split(strText, "<?")
	strSubParts = split(strParts(0),Dic("Private"))
	strResult = Util.HtmlEncode(StrParseText(strSubParts(0)))		' get any leading text less any old format private section
	For i=1 to Ubound(strParts)
		strSubParts = split(strParts(i), "?>")
		If Ubound(strSubParts) <> 1 Then Report.LogError Util.FormatString(Dic("ErrorTextFormat"), obj, strText)
		strParams = split(strSubParts(0), " ")
		Select Case LCase(strParams(0))
			Case "html"
				strResult = strResult & strSubParts(1)
				strMode = "<?" & strSubParts(0) & "?>"
			Case "text"
				strResult = strResult & Util.HtmlEncode(StrParseText(strSubParts(1)))
				strMode = "<?" & strSubParts(0) & "?>"
			Case "hide" 
			Case "image"
				strParams = Split(Trim(Mid(strSubParts(0),6)),"""")
				If Ubound(strParams)  <> 2 And UBound(strParams) <> 0 Then
					Report.LogError Util.FormatString(Dic("ErrorTextFormat"), obj, strSubParts(0))
				Else
					If UBound(strParams) = 2 Then
						If Trim(strParams(0)) <> "" Then Report.LogError Util.FormatString(Dic("ErrorTextFormat"), obj, strSubParts(0))
						strTemp = strParams(1)
						strParams = Split(g_eSpace.Replace(strParams(2), " ") & "  "," ")
						strParams(0) = strTemp
						strTemp = ""
					Else
						strTemp = Trim(g_eSpace.Replace(strParams(0), " "))
						strParams = Split(strTemp & "  "," ")
						strTemp=g_oPicMaps.KeyValue(strParams(0))
						strParams(0) = g_oPicIndex(strParams(0))
					End If
					strMap = ""
					If strTemp <> "" Then strMap = StrNewUID
					strResult = strResult & Util.FormatString("<div width='95%' style='text-align:center; overflow:auto;'>" & _
								"<img src='{}' class='pic' {}/>", _
								strParams(0), Util.FormatPhrase("[ width='{0}'][ height='{1}'][ usemap='#map{2}']", strParams(1), strParams(2), strMap))
					If strTemp<>"" Then strResult = strResult & Util.FormatString("<map name='map{}'>{}</map><div class='note'>{}</div>", strMap, strTemp, Dic("PictureMapHint"))
					strResult = strResult & "</div>"
					If UBound(strSubParts) > 0 Then strResult = strResult & StrFormatText(obj, strMode & strSubParts(1))		
				End If
			Case "merge"
				strParams = Split(Trim(Mid(strSubParts(0),6)),"""")
				strResult = strResult & StrMergeText(obj, strMode, strParams, 0)
				If UBound(strSubParts) > 0 Then strResult = strResult & StrFormatText(obj, strMode & strSubParts(1))		
			Case "note"
				strParams = Split(Trim(Mid(strSubParts(0),5)),"""")
				If Ubound(strParams)  < 2 Then
					Report.LogError Util.FormatString(Dic("ErrorTextFormat"), obj, strSubParts(0))
				ElseIf Trim(strParams(0)) <> "" Then
					Report.LogError Util.FormatString(Dic("ErrorTextFormat"), obj, strSubParts(0))
				Else
					strResult = strResult & StrHtmlAnnotation(obj, strParams(1), "<?html?>" & StrMergeText(obj, strMode, strParams, 2))
					If UBound(strSubParts) > 0 Then strResult = strResult & StrFormatText(obj, strMode & strSubParts(1))		
				End If
			Case "popup"
				strParams = Split(Trim(Mid(strSubParts(0),6)),"""")
				If Ubound(strParams)  < 4 Then
					Report.LogError Util.FormatString(Dic("ErrorTextFormat"), obj, strSubParts(0))
				ElseIf (Trim(strParams(0)) & Trim(strParams(2))) <> "" Then
					Report.LogError Util.FormatString(Dic("ErrorTextFormat"), obj, strSubParts(0))
				Else
					strUID = StrNewUid
					strResult = strResult & Util.FormatString("<div class='std'><a href=""javascript:savePopupContent('popup{}', '{&j}');displayPopup();showPopUpFrame('');"">{}</a></div>", strUID, strParams(1), strParams(3))
					strResult = strResult & Util.FormatString("<div id=""popup{}"" style=""display:none"">{}</div>", strUID, StrMergeText(obj, strMode, strParams, 4))
					If UBound(strSubParts) > 0 Then strResult = strResult & StrFormatText(obj, strMode & strSubParts(1))			
				End If
			Case "subsection"
				strParams = Split(Trim(Mid(strSubParts(0),11)),"""")
				If Ubound(strParams)  < 2 Then
					Report.LogError Util.FormatString(Dic("ErrorTextFormat"), obj, strSubParts(0))
				ElseIf Trim(strParams(0)) <> "" Then
					Report.LogError Util.FormatString(Dic("ErrorTextFormat"), obj, strSubParts(0))
				Else
					strResult = strResult & StrHtmlSubSection(obj, strParams(1), StrMergeText(obj, strMode, strParams, 2))
					If UBound(strSubParts) > 0 Then strResult = strResult & StrFormatText(obj, strMode & strSubParts(1))		
				End If
			Case Else Report.LogError Util.FormatString(Dic("ErrorTextToken"), obj, strParams(0))
		End Select
	Next
	StrFormatText = strResult		
End Function

Function StrHtmlSubSection(obj, strSectionType, strContent)
	If (strContent <> "") Then
		g_ichReferencesStart = -1 ' indicate at least one collapse/expand non-notes section present
		StrHtmlSubSection = Util.FormatString("<ul class='xT std'>" & vbNewline & _
				     	"  <li class='xT2-{} xT-h' onclick='xTclk(event,""2"")'><h3 class='xT-i inline'>{&t}</h3>" & vbNewline & _
				     	"    <ul class='xT-h'>" & vbNewline & _
				     	"     <li>{}" & vbNewline & _
				     	"     </li>" & vbNewline & _
				     	"    </ul>" & vbNewline & _
					"  </li>" & vbNewline & _
					"</ul>" & vbNewline, _
					Util.IfElse(g_fCollapseReferences, "c", "o"), strSectionType, strContent)
	End If
End Function

Function StrJavaScriptEncode(strValue)
' do proper JavaScript encoding, unlike Util.JavaScriptEncode 
	StrJavaScriptEncode = Replace(Replace(Replace(Replace(Replace(strValue, "\", "\\"),"""","\"""),"'","\'"), vbTab, "\t"), vbLineFeed, "\n")
End Function


Function StrMergeText(obj, strMode, strParams, nFirst)
	Dim strResult, i
	For i=nFirst To Ubound(strParams) Step 2
		If strParams(i) <> "" Then strResult = strResult & StrMergeTags(obj, strMode, Split(strParams(i)))
		If i < Ubound(strParams) Then strResult = strResult & strParams(i+1)
	Next
	StrMergeText = strResult
End Function

Function StrMergeTags(obj, strMode, strParams)
	Dim strResult
	For Each strCode In strParams
		If strCode <> "" Then strResult = strResult & StrFormatText(obj, strMode & CustomTag(obj, strCode))
	Next
	StrMergeTags = strResult
End Function	

Function StrParseText(strText)
' check for language specific sections, making skin language sections visible by default
Dim arrParts, arrSubParts, strResult, i, strLang
If Instr(strText,"{?") > 0 Then
	strResult = ""
	arrParts = split(Replace(strText,"}","{"),"{")
	For i=0 To UBound(arrParts) Step 2
		strResult = strResult & arrParts(i)
		If i < UBound(arrParts) Then
			If Left(arrParts(i+1),1) <> "?" Or Instr(arrParts(i+1),":") < 4 Then
				Report.LogError Util.FormatString(Dic("ErrorLangMarkup"), strText)
				Exit Function
			Else
				arrSubParts = Split(Mid(arrParts(i+1),2),":")
				If arrSubParts(0) = ReportGenerator.SkinLanguage Then
					strResult = strResult & Mid(arrParts(i+1), 3+Len(arrSubParts(0)))
				ElseIf g_LangShowOthers Then
					strLang = CustomTag(Null, "_" & arrSubParts(0))
					If strLang = "" Then strLang = arrSubParts(0)
					strResult=strResult & "(<span class='langtoggle' onclick=""javascript:this.nextSibling.style.display = (this.nextSibling.style.display == 'none' ? 'inline' : 'none');"">" & strLang & "</span><span style='display:none' onclick=""javascript:this.style.display = (this.style.display == 'none' ? 'inline' : 'none');"">: " & Util.HtmlEncode( Mid(arrParts(i+1), 3+Len(arrSubParts(0)))) & "</span>)"
				End If
			End If
		End If 
	Next	
	StrParseText = strResult
Else
	StrParseText = strText
End If
End Function

Function StrNewUID()
	g_UID = g_UID + 1
	StrNewUID = g_UID & ""
End Function

Function CustomTag(obj,tag)
On Error Resume Next
If Not IsNull(obj) Then		' ordinary custom tag
	CustomTag = obj.TagValue(tag)
Else				' Document custom Tag
	CustomTag = g_oGlobal.selectSingleNode(tag).text
End If
End Function

Function GetDate(oDate)
	If Not Util.IsNothing(oDate) Then GetDate = Util.FormatPhrase(Dic("FmtDateSort"), oDate.Year, Util.IfElse(oDate.Month<>"",Right("0" & oDate.Month,2),""), Util.IfElse(oDate.Day<>"",Right("0" & oDate.Day,2),""))
End Function

Function MatchDate(o, p, obj)
	If o.Id = p.ID And obj.ToStringNarrative <> "" Then
		Set MatchDate = obj
	Else
		Set MatchDate = Nothing
	End If
End Function

' Check the Private tag
Function isPrivate(obj)
	Select Case obj.Class
	Case "Individual"
		' An individual is private according to the Private custom tag.
		' If the tag is not defined, an individual is private unless dead.
		Select Case CustomTag(obj,"Private")
			Case "Y"
				isPrivate = True
			Case "N"
				isPrivate = False
			Case Else
				On Error Resume Next 
				If obj.isDead Then isPrivate = False Else isPrivate = True
		End Select
	Case "Family"
		' A family is private if either of the parents is private
		isPrivate = Eval((isPrivate(obj.Parents(0)) Or isPrivate(obj.Parents(1))))
	Case "Picture"
		' A picture is private unless it is referenced by at least one public object
		isPrivate = True
		If obj.References.Count Then
			For Each r in obj.References
				If Not isPrivate(r) Then
					isPrivate = False
					Exit For
				End If
			Next
		End If
	Case Else
		' All other objects are public.
		isPrivate = False
	End Select
End Function

' The above "isPrivate" function cannot be used for GenoMaps, as they do not have the Class attribute.
' So a special-case function just for GenoMaps is provided.
Function isPrivateGenoMap(g)
	isPrivateGenoMap = True
	For Each o in g.DrawingObjects.ToGenoCollection
		If o.Class = "Individual" And Not isPrivate(o) Then
			isPrivateGenoMap = False
			Exit For
		End If
	Next
End Function

' This function replaces all the email addresses in a string with links to the Recaptcha.net website.
' It uses the regular expression match for email addresses from http://www.regular-expressions.info/email.html
' For instructions on how to set up a hidden email address go to http://mailhide.recaptcha.net/
' which will return a URL that your user can link to to display the email after solving a "captcha" puzzle.
' To set up Genopro to use the recaptcha URL, set up an email address and the following custom tags in
' the Contacts section for the individual whose email address is to be hidden:
'   Recaptcha.url     - contains the URL returned to you at mailhide.recaptcha.net
'   Recaptcha.display - contains the name that is to appear as the link to that URL
Function captchaEmailAddresses(strComment)
	Dim strParsedComment, strParse, strEmail, Match
	Set strParse = new RegExp
	strParse.Pattern ="[A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z]{2,4}"
	strParse.Global=True
	strParse.IgnoreCase=True
	Set strParsedComment = strParse.Execute(strComment)
	If strParsedComment.Count >0 Then
		nPos=1
		captchaEmailAddresses = ""
		For Each Match in strParsedComment
			Report.LogWarning "File " & Report.FileOutput & " contains email address: " & Match.Value
			strEmail = Lcase(Match.Value)
			n = Match.FirstIndex - nPos + 1
			captchaEmailAddresses = captchaEmailAddresses & _
			  Util.HtmlEncode(Rtrim(Mid(strComment,nPos,n))) & captchaEmailAddress(strEmail)
			nPos = nPos + n + Match.Length
		Next
				captchaEmailAddresses = captchaEmailAddresses & Util.HtmlEncode(Mid(strComment,nPos))
	Else
		captchaEmailAddresses =  Util.HtmlEncode(strComment)
	End If
End Function

' This function replaces a single email address with a link to the 
' Recaptcha URL obtained from the corresponding custom tag.
Function captchaEmailAddress(email)
	dim strEmail, strUrl, strDisplay, strFeat
	strEmail = Lcase(email)
	strUrl = Empty
	strDisplay = "Contact"
	For Each c in Contacts
		If strEmail = Lcase(c.Email) Then
			strUrl     = Util.HrefEncode(CustomTag(c,"Recaptcha.url"))
			strDisplay = CustomTag(c,"Recaptcha.display")  
			Exit For
		End If
	Next
	If strUrl = Empty Then
		Report.LogWarning Util.FormatString("Email address {} in {} not replaced with Recaptcha link.", _
		                                    strEmail, Report.FileOutput)
		captchaEmailAddress = vbNewline & strEmail
	Else
		strFeat = "toolbar=0,scrollbars=0,location=0,statusbar=0,menubar=0,resizable=1," & _
		          "top=30,left=30,width=500,height=300"
		strUrl = Replace(strUrl, "&", "&amp;", 1, -1, 1)
		strTitle = "Reveal the e-mail address for"
		captchaEmailAddress = vbNewline & _
			Util.FormatString("<a href=""{0}"" onclick=""window.open('{0}','','{1}');return false;"" title=""{2} {3}"">{3}</a>",_
			                  strUrl, strFeat, strTitle, strDisplay)
	End If
End Function
